/*
 *      p9-2.c 
 *      Beispielprogramm 2, Abschnitt 9
 *      Realisierung des Kommandos cat
 */

#include <stdio.h>

void filecopy(FILE *);

void main(int argc, char *argv[])
{
  FILE *fp;
  
  if (argc == 1)        /* ohne Argumente */
    filecopy(stdin);    /* Standard Eingabe kopieren */
  else {
    while (--argc > 0) {
      if ((fp = fopen(*++argv, "r")) == NULL) {
	fprintf(stderr, "cat: can't open %s\n", *argv);
	exit(1);
      } 
      else {
	filecopy(fp);
	fclose(fp);
      }
    }
  }
  exit(0);
  
} /* main() */

/* Datei fp als Standard Ausgabe ausgeben */
void filecopy(register FILE *fp)   
{
  register int c;
  
  while ((c = getc(fp)) != EOF)
    putc(c, stdout);
    
} /* filecopy() */
