/*
 *      p5-1.c
 *      Beispielprogramm 1, Abschnitt 5
 *      Binaeres Suchen von x im 
 *      sortierten Feld v[0] .. v[n-1]
 */

int binary(int x, int v[], int n)
{
  int low, high, mid;
  
  low = 0;
  high = n - 1;
  while (low <= high) {
    mid = (low + high) / 2;
    if (x < v[mid])
      high = mid - 1;
    else if (x > v[mid])
      low  = mid + 1;
    else        /* gefunden */
      return (mid);
  }
  return (-1);  /* Fehlerkennung */

} /* binary() */
