/*
 *      p7-2.c
 *      Beispielprogramm 2, Abschnitt 7
 *      Vertauschen von Parametern
 */

#include <stdio.h>

void no_swap(int, int);
void do_swap(int *, int *);

void main(void)
{
  int i, j;
  
  i = 5; j = 10;
  printf("i=%2d j=%2d\n", i, j);
  no_swap(i, j);
  printf("i=%2d j=%2d\n", i, j);
  do_swap(&i, &j);
  printf("i=%2d j=%2d\n", i, j);
  
} /* main() */
  
/* Funktioniert nicht, da Werte uebergeben werden */
void no_swap(int x,int y)
{
  int temp;
  
  temp = x;
  x = y;
  y = temp;

} /* no_swap() */ 

/* Funktioniert, da Adressen uebergeben werden */
void do_swap(int *px, int *py)
{
  int temp;
  
  temp = *px;
  *px = *py;
  *py = temp;

} /* do_swap() */
