/*
 *      mem1.c
 *      klin, Wed Dec 17 15:08:57 1997
 *      Adressbereiche von Variablenklassen
 */

#include <stdio.h>

int e_v1 = 123;         /* Extern 1 */
int e_v2;               /* Extern 2 */

static int s_v1 = 456;  /* Static 1 */
static int s_v2;        /* Static 2 */

void main(void)
{
  static s_v3;          /* Static 3 */
  int a_v1 = 789;       /* Automatic 1 */
  int a_v2;             /* Automatic 2 */
  
  printf("Externe, statische und automatische Variable\n\n");
  
  printf("Function:  main: %08p / %010lu\n", main, main);
  
  printf("Extern:    e_v1: %08p / %010lu %d\n", &e_v1, &e_v1, e_v1);
  printf("Extern:    e_v2: %08p / %010lu %d\n", &e_v2, &e_v2, e_v2);
  
  printf("Static:    s_v1: %08p / %010lu %d\n", &s_v1, &s_v1, s_v1);
  printf("Static:    s_v2: %08p / %010lu %d\n", &s_v2, &s_v2, s_v2);
  printf("Static:    s_v3: %08p / %010lu %d\n", &s_v3, &s_v3, s_v3);
  
  printf("Automatic: a_v1: %08p / %010lu %d\n", &a_v1, &a_v1, a_v1);
  printf("Automatic: a_v2: %08p / %010lu %d\n", &a_v2, &a_v2, a_v2);
    
} /* main() */
