/*
 *      mem3.c
 *      klin, Wed Dec 17 15:08:57 1997
 *      Pufferueberlauf
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define N 4
#define M 8
#define byte unsigned char

void puthex(byte *, int);

void main(void)
{
  char *s = "Dummystring";
  int i, j, k;
  char a4[N][M];

  printf("Pufferueberlauf\n\n");
  
  printf("s=%p a4=%p i=%p j=%p k=%p\n", &s, &a4, &i, &j, &k);
  printf("a4  a = %p/%p  s = %d\n", a4, &a4, sizeof(a4));
  puthex((byte *) a4, sizeof(a4));
  for (i = 0; i < N; i++)
    printf("a4(%d) = %p/%p\n", i, a4[i], &a4[i]);

  strcpy(a4[0], "Dieser String ist viel zu lang! XXXXYYYY");
  printf("i=%p/%p j=%p/%p k=%p/%p\n", i, &i, j, &j, k, &k);
  puthex((byte *) a4, sizeof(a4)+3*sizeof(int));
  for (i = 0; i < N; i++)
    printf("a4(%d) = %p/%p \"%s\"\n", i, a4[i], &a4[i], a4[i]);
    
} /* main() */

void puthex(byte *s, int n)
{
  int i;
  
  for (i = 0; i < n; i++) {
    printf("%02x", s[i]);
  }
  printf("\n");
  for (i = 0; i < n; i++) {
    printf("%2c", isprint(s[i]) ? s[i] : '.');
  }
  printf("\n");

} /* puthex() */
