/*
 *      mem4.c
 *      klin, Wed Dec 17 15:08:57 1997
 *      Speicherabbildung von Structs
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define N 2
#define byte unsigned char

void puthex(byte *, int);

struct _st {
  int n;
  char s[4];
} st[N] = {
  0x11111111, "111",
  0x22222222, "222",  
};
  
void main(void)
{
  int i;
    
  printf("Speicherabbildung von Structs\n\n");
  
  printf("s _st = %d, st = %d, a st = %p\n", sizeof(struct _st), st, &st);
  puthex((byte *) &st, sizeof(st));
  for (i = 0; i < N; i++) {
    printf("st[%d] a=%p n=%10d/%08x s=%s\n", i, &st[i], st[i].n, st[i].n, st[i].s);
    puthex((byte *) &st[i], sizeof(st[i]));
  }    
    
} /* main() */

void puthex(byte *s, int n)
{
  int i;
  
  for (i = 0; i < n; i++) {
    printf("%02x", s[i]);
  }
  printf("\n");
  for (i = 0; i < n; i++) {
    printf("%2c", isprint(s[i]) ? s[i] : '.');
  }
  printf("\n");

} /* puthex() */
